#include <fork.h>
#include <assert.h>
#include <syscall.h>
#include <io.h>


void main(void) 
{
 pr unsigned int t;
 t = getct();
 if (__PROC_NR__==0)
   if (__STARTED_PROCS__ >=4)
     pprintf("Using 4 of the %d processors\n\n", __STARTED_PROCS__); 
 barrier;
 pprintf("'Hello world' from processor %d, rank %d, hardware ID %d\n",
          $, $$, getnr());
 start {
   if ($$ < #/2)
     farm
       pprintf("then: 'Goodbye world' from processor %d, group ID %d, rank %d, size %d\n",
                $, @, $$, groupsize());
   else
     farm 
       pprintf("else: 'Goodbye world' from processor %d, group ID %d, rank %d, size %d\n",
                $, @, $$, groupsize());
     
 }
 t = getct() - t;
 if (__PROC_NR__==0)
    pprintf("Parallel execution time:  %d msec\n", t >> 8);
 barrier;
}
