#include <fork.h> /*always required in Fork programs*/
#include <io.h>       /*we use the printf() routine */ 

sh simple_lock screen = 0;

void dojoin( void ) 
{
 join( 100; __NUM_PR__>=1; __RANK__<2)
     farm pprintf("JOIN-BODY! $=%d $$=%d\n",$, $$);
 else {
     pprintf("ELSE-PART! $=%d $$=%d\n", $, $$); 
     continue;  /* go back to join head */
                /* break would leave it */
 }
}

void main(void)
{
 start {
  initTracing( 10000 );
  startTracing();
  farm 
    dojoin();
  stopTracing();
  writeTraceFile("jointest.trv", "test of join statement" );
 }
}

